<template>
  <fieldset>
    <fieldset>
      <TextInputFloatingLabel
          for="rotationInterval"
          :text="t('rotation_interval_label')"
      >
        <input
            type="number"
            id="rotationInterval"
            name="rotationInterval"
            min="1"
            step="1"
            max="5000"
            :value="currentSettings.rotationInterval"
        />
      </TextInputFloatingLabel>
      <RadioToggleBorderedLabel
          :active="currentSettings.remoteFiles"
          field-id="remoteFiles"
          :text="t('remote_files_toggle_label')"
      >
      </RadioToggleBorderedLabel>
      <input
          type="hidden"
          name="pictureIds"
          id="pictureIds"
          :value="currentSettings.pictureIds"
      />
      <input
          type="hidden"
          id="remotePictureUrls"
          name="remotePictureUrls"
          :value="currentSettings.remotePictureUrls"
      />
    </fieldset>
    <fieldset v-if="currentSettings.remoteFiles">
      <div class="input-group">
        <TextInputFloatingLabel
            for="remotePictureUrlInput"
            :text="t('remote_url_label')"
        >
          <input
              type="url"
              id="remotePictureUrlInput"
              pattern="http[s]{0,1}://.*"
              placeholder="https://domain.tld/picture.jpeg"
              required
              v-model="remotePictureUrlInput"
              @change="cancel"
              class="input-group-field"
          />
        </TextInputFloatingLabel>
        <div class="input-group-button">
          <button
              type="button"
              class="button"
              @click="addRemotePictureUrl"
              :disabled="!remotePictureUrlInput"
          >
            {{ t("add") }}
          </button>
        </div>
      </div>
      <ol>
        <li
            v-for="(url, idx) in remotePictureUrls"
            :key="idx"
            class="remote-pic"
        >
          <span>
            <img
                :src="url"
                alt="¯\_(ツ)_/¯"
                loading="lazy"
                decoding="async"
                class="remote-pic__preview"
            />
            <span class="remote-pic__url">{{ url }}</span></span
          >
          <button
              type="button"
              class="button alert"
              @click="removeRemotePictureUrl(idx)"
          >
            X
          </button>
        </li>
      </ol>
    </fieldset>
    <fieldset v-else>
      <fieldset @change.prevent="cancel">
        <section id="preview">
          <div v-for="pic in pictures" :key="pic.id" class="image__wrapper">
            <img
                :src="pic.file_url"
                :alt="pic.title"
                width="auto"
                height="50"
            />
            <button
                type="button"
                class="delete-button delete-button--image"
                @click="deletePicture(pic.id)"
            >
              x
            </button>
          </div>
        </section>
        <div class="upload-controls">
          <button
              v-if="selectedFile"
              type="button"
              class="button hollow alert"
              @click="clearFileInput"
          >
            x
          </button>
          <label for="pictureImageFile" class="button hollow">{{
              selectedFile.length > 0 ? selectedFile : t("file_input_label")
            }}</label>
          <input
              type="file"
              id="pictureImageFile"
              class="show-for-sr"
              name="upload[file]"
              required
              accept="image/*"
              @change.prevent="setInputState"
          />
          <input
              type="submit"
              class="button"
              @click.prevent="uploadPicture"
              :disabled="selectedFile.length === 0 || uploading"
              :value="uploadButtonLabel"
          />
        </div>
      </fieldset>
      <p v-if="error" class="pictures__error">{{ error }}</p>
    </fieldset>
  </fieldset>
</template>

<script>
module.exports = {
  name: "pictures",
  props: {
    currentSettings: {
      type: Object,
      required: true,
    },
    locale: {
      type: String,
      required: true,
    },
    backendUrl: {
      type: String,
      required: true,
    },
  },
  data: function () {
    return {
      pictures: [],
      selectedFile: "",
      uploading: false,
      remotePictureUrlInput: "",
      error: ""
    };
  },
  computed: {
    pictureIds: function () {
      return JSON.parse(this.currentSettings.pictureIds);
    },
    remotePictureUrls: function () {
      try {
        return JSON.parse(this.currentSettings.remotePictureUrls);
      } catch (error) {
        return [];
      }
    },
    uploadButtonLabel: function () {
      return this.uploading
          ? this.$translate.text("upload_button_uploading_state")
          : this.$translate.text("upload_button_label");
    },
  },
  beforeMount() {
    this.fetchPictures();
  },
  methods: {
    cancel: function (e) {
      e.stopPropagation();
    },
    setInputState: function (e) {
      this.selectedFile =
          e.target.files[0] !== undefined ? e.target.files[0].name : "";
    },
    clearFileInput: function () {
      const fileInput = document.getElementById("pictureImageFile");
      fileInput.value = "";
      fileInput.dispatchEvent(new Event("change"));
    },
    uploadPicture: async function (e) {
      let fd = new FormData(e.target.form);
      try {
        this.uploading = true;
        const response = await fetch(
            `${this.backendUrl}/pictures/picture_uploads`,
            {
              method: "POST",
              body: fd,
            }
        )
        const data = await response.json();
        if (!response.ok) {
          this.error = data;
          return;
        }

        this.pictures.push(data);

        let idInput = document.getElementById("pictureIds");
        idInput.value = JSON.stringify([...this.pictureIds, data.id]);
        this.triggerRotationIntervalSetting();
        idInput.dispatchEvent(new Event("change", {bubbles: true}));
      } catch (error) {
        this.error = error;
      } finally {
        e.target.form.reset();
        this.selectedFile = "";
        this.uploading = false;
      }
    },
    deletePicture: async function (id) {
      await fetch(`${this.backendUrl}/pictures/picture_uploads/${id}`, {
        method: "DELETE",
      });
      this.pictures = this.pictures.filter((pic) => pic.id !== id);
      let idInput = document.getElementById("pictureIds");
      idInput.value = JSON.stringify(
          this.pictureIds.filter((picId) => picId !== id)
      );
      idInput.dispatchEvent(new Event("change", {bubbles: true}));
    },
    fetchPictures: async function () {
      const data = await fetch(
          `${this.backendUrl}/pictures/picture_uploads`
      ).then((res) => res.json());
      this.pictures = data.filter((pic) => this.pictureIds.includes(pic.id));
    },
    addRemotePictureUrl: function () {
      let urlInput = document.getElementById("remotePictureUrls");
      urlInput.value = JSON.stringify([
        ...this.remotePictureUrls,
        this.remotePictureUrlInput,
      ]);
      this.triggerRotationIntervalSetting();
      urlInput.dispatchEvent(new Event("change", {bubbles: true}));
      this.remotePictureUrlInput = "";
    },
    removeRemotePictureUrl: function (idx) {
      let urlInput = document.getElementById("remotePictureUrls");
      let copy = this.remotePictureUrls;
      copy.splice(idx, 1);
      urlInput.value = JSON.stringify(copy);
      urlInput.dispatchEvent(new Event("change", {bubbles: true}));
    },
    /*
      FIXME: Workaround until defaults are initialized by backend. This prevents saving an empty rotation interval for
       newly placed instances: Vue binds the default value, but it's not available to FormData collection when the
       `change` event is triggered programmatically.
     */
    triggerRotationIntervalSetting: function () {
      let rotationInput = document.getElementById("rotationInterval");
      rotationInput.value = this.currentSettings.rotationInterval;
    },
  },
  locales: {
    enGb: {
      rotation_interval_label: "Seconds to display each image",
      file_input_label: "Choose image file",
      upload_button_label: "Upload image",
      upload_button_uploading_state: "Uploading …",
      remote_files_toggle_label: "Embed images from URL",
      remote_url_label: "Image file URL",
      add: "add",
    },
    deDe: {
      rotation_interval_label: "Anzeigedauer pro Bild (Sekunden)",
      file_input_label: "Bild-Datei wählen",
      upload_button_label: "Bild hochladen",
      upload_button_uploading_state: "Hochladen …",
      remote_files_toggle_label: "Bilder per URL einbinden",
      remote_url_label: "URL einer Bilddatei",
      add: "zufügen",
    },
    frFr: {
      rotation_interval_label: "Secondes pour afficher chaque image",
      file_input_label: "Choisissez un fichier image",
      upload_button_label: "Télécharger l'image",
      upload_button_uploading_state: "Téléchargement ...",
      remote_files_toggle_label: "Intégrer des images à partir de l'URL",
      remote_url_label: "URL du fichier d'image",
      add: "ajouter",
    },
    esEs: {
      rotation_interval_label: "Segundos para mostrar cada imagen",
      file_input_label: "Elija el archivo de imagen",
      upload_button_label: "Subir imagen",
      upload_button_uploading_state: "Subiendo...",
      remote_files_toggle_label: "Incrustar imágenes de la URL",
      remote_url_label: "URL del archivo de la imagen",
      add: "añadir",
    },
    plPl: {
      rotation_interval_label: "Sekundy do wyświetlenia każdego obrazu",
      file_input_label: "Wybierz plik z obrazem",
      upload_button_label: "Prześlij obrazek",
      upload_button_uploading_state: "Przesyłanie...",
      remote_files_toggle_label: "Osadzanie zdjęć z adresu URL",
      remote_url_label: "URL pliku z obrazem",
      add: "Dodaj",
    },
    koKr: {
      rotation_interval_label: "각 이미지를 표시하는 데 걸리는 시간",
      file_input_label: "이미지 파일 선택",
      upload_button_label: "이미지 업로드",
      upload_button_uploading_state: "업로드 중…",
      remote_files_toggle_label: "URL에서 이미지 삽입",
      remote_url_label: "이미지 파일 URL",
      add: "더하다",
    },
  },
};
</script>
<style scoped>
#preview {
  display: flex;
  justify-content: flex-start;
  flex-wrap: wrap;
}

.image__wrapper img {
  background-color: black;
}

.image__wrapper {
  position: relative;
  width: 25%;
  padding: 0 1rem;
  box-sizing: border-box;
}

.delete-button {
  background-color: rgba(100, 100, 100, 0.5);
  width: 2rem;
  height: 2rem;
  color: white;
}

.delete-button--image {
  position: absolute;
  top: 0;
  right: 1rem;
}

.upload-controls {
  display: flex;
  justify-content: space-between;
}

.remote-pic {
  display: flex;
  align-items: center;
  justify-content: space-between;
}

.remote-pic__preview {
  max-width: 3.125rem;
  max-height: 3.125rem;
}

.remote-pic__url {
  white-space: nowrap;
  overflow-x: hidden;
  text-overflow: ellipsis;
}

.pictures__error {
  color: red;
}
</style>
